Index: /branches/OMEdit/OMEditGUI/PolygonAnnotation.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/PolygonAnnotation.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/PolygonAnnotation.cpp	(revision 13537)
@@ -36,11 +36,11 @@
 #include "PolygonAnnotation.h"
 
-PolygonAnnotation_OMC::PolygonAnnotation_OMC(QString annotation, Component_OMC *pParent)
-  : ShapeAnnotation_OMC(pParent)
+PolygonAnnotation::PolygonAnnotation(QString annotation, Component *pParent)
+  : ShapeAnnotation(pParent)
 {
   parseShapeAnnotation(annotation);
 }
 
-void PolygonAnnotation_OMC::parseShapeAnnotation(QString annotation)
+void PolygonAnnotation::parseShapeAnnotation(QString annotation)
 {
   GraphicItem::parseShapeAnnotation(annotation);
@@ -62,10 +62,10 @@
 }
 
-QRectF PolygonAnnotation_OMC::boundingRect() const
+QRectF PolygonAnnotation::boundingRect() const
 {
   return shape().boundingRect();
 }
 
-QPainterPath PolygonAnnotation_OMC::shape() const
+QPainterPath PolygonAnnotation::shape() const
 {
   QPainterPath path;
@@ -74,5 +74,5 @@
 }
 
-void PolygonAnnotation_OMC::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
+void PolygonAnnotation::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
 {
   Q_UNUSED(option);
@@ -81,5 +81,5 @@
 }
 
-void PolygonAnnotation_OMC::drawPolygonAnnotaion(QPainter *painter)
+void PolygonAnnotation::drawPolygonAnnotaion(QPainter *painter)
 {
   applyLinePattern(painter);
@@ -90,280 +90,2 @@
   painter->drawPath(path);
 }
-
-
-
-
-PolygonAnnotation::PolygonAnnotation(QString shape, Component *pParent)
-  : ShapeAnnotation(pParent), mpComponent(pParent)
-{
-  initializeFields();
-  parseShapeAnnotation(shape, mpComponent->getOMCProxy());
-}
-
-PolygonAnnotation::PolygonAnnotation(GraphicsView *graphicsView, QGraphicsItem *pParent)
-  : ShapeAnnotation(graphicsView, pParent)
-{
-  // initialize all fields with default values
-  initializeFields();
-  mIsCustomShape = true;
-  setAcceptHoverEvents(true);
-  connect(this, SIGNAL(updateShapeAnnotation()), mpGraphicsView, SLOT(addClassAnnotation()));
-}
-
-PolygonAnnotation::PolygonAnnotation(QString shape, GraphicsView *graphicsView, QGraphicsItem *pParent)
-  : ShapeAnnotation(graphicsView, pParent)
-{
-  // initialize all fields with default values
-  initializeFields();
-  parseShapeAnnotation(shape, mpGraphicsView->getModelWidget()->getModelWidgetContainer()->getMainWindow()->getOMCProxy());
-  mIsCustomShape = true;
-  setAcceptHoverEvents(true);
-  connect(this, SIGNAL(updateShapeAnnotation()), mpGraphicsView, SLOT(addClassAnnotation()));
-}
-
-QRectF PolygonAnnotation::boundingRect() const
-{
-  return shape().boundingRect();
-}
-
-QPainterPath PolygonAnnotation::shape() const
-{
-  QPainterPath path;
-  path.addPolygon(QPolygonF(mPoints));
-  return addPathStroker(path);
-}
-
-void PolygonAnnotation::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
-{
-  Q_UNUSED(option);
-  Q_UNUSED(widget);
-
-  drawPolygonAnnotaion(painter);
-}
-
-void PolygonAnnotation::drawPolygonAnnotaion(QPainter *painter)
-{
-  QPainterPath path;
-
-  switch (this->mFillPattern)
-  {
-    case Qt::LinearGradientPattern:
-    case Qt::Dense1Pattern:
-    case Qt::RadialGradientPattern:
-      painter->setBrush(QBrush(this->mFillColor, Qt::SolidPattern));
-      break;
-    default:
-      painter->setBrush(QBrush(this->mFillColor, this->mFillPattern));
-      break;
-  }
-
-  qreal thickness;
-  // if (mCornerRadius > 0) // this is commented intentionally so that we dont need path stroker. Also helps in svg rendering
-  thickness = ceil(mThickness);
-
-  QPen pen(this->mLineColor, thickness, this->mLinePattern);
-  pen.setCosmetic(true);
-  painter->setPen(pen);
-
-  path.addPolygon(QPolygonF(mPoints));
-  painter->drawPath(path);
-}
-
-void PolygonAnnotation::addPoint(QPointF point)
-{
-  mPoints.append(point);
-  mPoints.back() = mPoints.first();
-}
-
-void PolygonAnnotation::updateEndPoint(QPointF point)
-{
-  // we update the second last point for polygon since the last point is connected to first one
-  mPoints.replace(mPoints.size() - 2, point);
-}
-
-void PolygonAnnotation::drawRectangleCornerItems()
-{
-  mIsFinishedCreatingShape = true;
-  // remove the last point since mouse double click event has added an extra point to it.....
-  mPoints.remove(mPoints.size() - 1);
-  // the loop should run -1 size so that we dont have two corner item for starting and ending points
-  for (int i = 0 ; i < this->mPoints.size() - 1 ; i++)
-  {
-    QPointF point = this->mPoints.at(i);
-    RectangleCornerItem *rectangleCornerItem = new RectangleCornerItem(point.x(), point.y(), i, this);
-    mRectangleCornerItemsList.append(rectangleCornerItem);
-  }
-  emit updateShapeAnnotation();
-}
-
-QString PolygonAnnotation::getShapeAnnotation()
-{
-  QString annotationString;
-  annotationString.append("Polygon(");
-
-  if (!mVisible)
-  {
-    annotationString.append("visible=false,");
-  }
-
-  annotationString.append("points={");
-  for (int i = 0 ; i < mPoints.size() ; i++)
-  {
-    annotationString.append("{").append(QString::number(mapToScene(mPoints[i]).x())).append(",");
-    annotationString.append(QString::number(mapToScene(mPoints[i]).y())).append("}");
-    if (i < mPoints.size() - 1)
-      annotationString.append(",");
-  }
-  annotationString.append("},");
-
-  annotationString.append("rotation=").append(QString::number(this->rotation())).append(",");
-
-  annotationString.append("lineColor={");
-  annotationString.append(QString::number(mLineColor.red())).append(",");
-  annotationString.append(QString::number(mLineColor.green())).append(",");
-  annotationString.append(QString::number(mLineColor.blue()));
-  annotationString.append("},");
-
-  annotationString.append("fillColor={");
-  annotationString.append(QString::number(mFillColor.red())).append(",");
-  annotationString.append(QString::number(mFillColor.green())).append(",");
-  annotationString.append(QString::number(mFillColor.blue()));
-  annotationString.append("},");
-
-  QMap<QString, Qt::PenStyle>::iterator it;
-  for (it = this->mLinePatternsMap.begin(); it != this->mLinePatternsMap.end(); ++it)
-  {
-    if (it.value() == mLinePattern)
-    {
-      annotationString.append("pattern=LinePattern.").append(it.key()).append(",");
-      break;
-    }
-  }
-
-  QMap<QString, Qt::BrushStyle>::iterator fill_it;
-  for (fill_it = this->mFillPatternsMap.begin(); fill_it != this->mFillPatternsMap.end(); ++fill_it)
-  {
-    if (fill_it.value() == mFillPattern)
-    {
-      annotationString.append("fillPattern=FillPattern.").append(fill_it.key()).append(",");
-      break;
-    }
-  }
-
-  annotationString.append("lineThickness=").append(QString::number(mThickness));
-  if (mSmooth)
-  {
-    annotationString.append(",smooth=Smooth.Bezier");
-  }
-
-  annotationString.append(")");
-  return annotationString;
-}
-
-void PolygonAnnotation::updatePoint(int index, QPointF point)
-{
-  // if updating the starting point then update the end point with it as well
-  if (index == 0)
-  {
-    mPoints.replace(index, point);
-    mPoints.back() = mPoints.first();
-  }
-  else
-  {
-    mPoints.replace(index, point);
-  }
-}
-
-void PolygonAnnotation::parseShapeAnnotation(QString shape, OMCProxy *omc)
-{
-  // parse the shape to get the list of attributes of Polygon.
-  QStringList list = StringHandler::getStrings(shape);
-  if (list.size() < 8)
-  {
-    return;
-  }
-
-  // if first item of list is true then the Polygon should be visible.
-  this->mVisible = static_cast<QString>(list.at(0)).contains("true");
-
-  int index = 0;
-  QStringList originList = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(list.at(1)));
-  mOrigin.setX(static_cast<QString>(originList.at(0)).toFloat());
-  mOrigin.setY(static_cast<QString>(originList.at(1)).toFloat());
-  mRotation = static_cast<QString>(list.at(2)).toFloat();
-  index = 2;
-  // second item of list contains the color.
-  index = index + 1;
-  QStringList colorList = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(list.at(index)));
-  if (colorList.size() < 3)
-  {
-    return;
-  }
-
-  int red = static_cast<QString>(colorList.at(0)).toInt();
-  int green = static_cast<QString>(colorList.at(1)).toInt();
-  int blue = static_cast<QString>(colorList.at(2)).toInt();
-  this->mLineColor = QColor (red, green, blue);
-
-  // third item of list contains the color.
-  index = index + 1;
-  QStringList fillColorList = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(list.at(index)));
-  if (fillColorList.size() < 3)
-  {
-    return;
-  }
-
-  red = static_cast<QString>(fillColorList.at(0)).toInt();
-  green = static_cast<QString>(fillColorList.at(1)).toInt();
-  blue = static_cast<QString>(fillColorList.at(2)).toInt();
-  this->mFillColor = QColor (red, green, blue);
-
-  // fourth item of list contains the Line Pattern.
-  index = index + 1;
-  QString linePattern = StringHandler::getLastWordAfterDot(list.at(index));
-  QMap<QString, Qt::PenStyle>::iterator it;
-  for (it = this->mLinePatternsMap.begin(); it != this->mLinePatternsMap.end(); ++it)
-  {
-    if (it.key().compare(linePattern) == 0)
-    {
-      this->mLinePattern = it.value();
-      break;
-    }
-  }
-
-  // fifth item of list contains the Line Pattern.
-  index = index + 1;
-  QString fillPattern = StringHandler::getLastWordAfterDot(list.at(index));
-  QMap<QString, Qt::BrushStyle>::iterator fill_it;
-  for (fill_it = this->mFillPatternsMap.begin(); fill_it != this->mFillPatternsMap.end(); ++fill_it)
-  {
-    if (fill_it.key().compare(fillPattern) == 0)
-    {
-      this->mFillPattern = fill_it.value();
-      break;
-    }
-  }
-
-  // sixth item of list contains the thickness.
-  index = index + 1;
-  this->mThickness = static_cast<QString>(list.at(index)).toFloat();
-
-  // seventh item of list contains the points.
-  index = index + 1;
-  QStringList pointsList = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(list.at(index)));
-  foreach (QString point, pointsList)
-  {
-    QStringList polygonPoints = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(point));
-    if (polygonPoints.size() < 2)
-      return;
-
-    qreal x = static_cast<QString>(polygonPoints.at(0)).toFloat();
-    qreal y = static_cast<QString>(polygonPoints.at(1)).toFloat();
-    QPointF p (x, y);
-    this->mPoints.append(p);
-  }
-
-  // eighth item of the list contains the corner radius.
-  index = index + 1;
-  this->mSmooth = static_cast<QString>(list.at(index)).toLower().contains("smooth.bezier");
-}
Index: /branches/OMEdit/OMEditGUI/PolygonAnnotation.h
===================================================================
--- /branches/OMEdit/OMEditGUI/PolygonAnnotation.h	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/PolygonAnnotation.h	(revision 13537)
@@ -41,11 +41,11 @@
 
 class OMCProxy;
-class Component_OMC;
+class Component;
 
-class PolygonAnnotation_OMC : public ShapeAnnotation_OMC
+class PolygonAnnotation : public ShapeAnnotation
 {
   Q_OBJECT
 public:
-  PolygonAnnotation_OMC(QString annotation, Component_OMC *pParent);
+  PolygonAnnotation(QString annotation, Component *pParent);
   void parseShapeAnnotation(QString annotation);
   QRectF boundingRect() const;
@@ -55,26 +55,3 @@
 };
 
-
-class PolygonAnnotation : public ShapeAnnotation
-{
-  Q_OBJECT
-public:
-  PolygonAnnotation(QString shape, Component *pParent);
-  PolygonAnnotation(GraphicsView *graphicsView, QGraphicsItem *pParent = 0);
-  PolygonAnnotation(QString shape, GraphicsView *graphicsView, QGraphicsItem *pParent = 0);
-  QRectF boundingRect() const;
-  QPainterPath shape() const;
-  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget = 0);
-  void drawPolygonAnnotaion(QPainter *painter);
-  void addPoint(QPointF point);
-  void updateEndPoint(QPointF point);
-  void drawRectangleCornerItems();
-  QString getShapeAnnotation();
-  void parseShapeAnnotation(QString shape, OMCProxy *omc);
-
-  Component *mpComponent;
-public slots:
-  void updatePoint(int index, QPointF point);
-};
-
 #endif // POLYGONANNOTATION_H
Index: /branches/OMEdit/OMEditGUI/RectangleAnnotation.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/RectangleAnnotation.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/RectangleAnnotation.cpp	(revision 13537)
@@ -36,11 +36,11 @@
 #include "RectangleAnnotation.h"
 
-RectangleAnnotation_OMC::RectangleAnnotation_OMC(QString annotation, Component_OMC *pParent)
-  : ShapeAnnotation_OMC(pParent)
+RectangleAnnotation::RectangleAnnotation(QString annotation, Component *pParent)
+  : ShapeAnnotation(pParent)
 {
   parseShapeAnnotation(annotation);
 }
 
-void RectangleAnnotation_OMC::parseShapeAnnotation(QString annotation)
+void RectangleAnnotation::parseShapeAnnotation(QString annotation)
 {
   GraphicItem::parseShapeAnnotation(annotation);
@@ -64,10 +64,10 @@
 }
 
-QRectF RectangleAnnotation_OMC::boundingRect() const
+QRectF RectangleAnnotation::boundingRect() const
 {
   return shape().boundingRect();
 }
 
-QPainterPath RectangleAnnotation_OMC::shape() const
+QPainterPath RectangleAnnotation::shape() const
 {
   QPainterPath path;
@@ -76,5 +76,5 @@
 }
 
-void RectangleAnnotation_OMC::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
+void RectangleAnnotation::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
 {
   Q_UNUSED(option);
@@ -87,5 +87,5 @@
 }
 
-void RectangleAnnotation_OMC::drawRectangleAnnotaion(QPainter *painter)
+void RectangleAnnotation::drawRectangleAnnotaion(QPainter *painter)
 {
   applyLinePattern(painter);
@@ -115,303 +115,2 @@
   painter->drawRoundedRect(getBoundingRect(), mRadius, mRadius);
 }
-
-
-
-
-
-RectangleAnnotation::RectangleAnnotation(QString shape, Component *pParent)
-  : ShapeAnnotation(pParent), mpCompnent(pParent)
-{
-  initializeFields();
-  parseShapeAnnotation(shape, mpCompnent->getOMCProxy());
-}
-
-RectangleAnnotation::RectangleAnnotation(GraphicsView *graphicsView, QGraphicsItem *pParent)
-  : ShapeAnnotation(graphicsView, pParent)
-{
-  // initialize all fields with default values
-  initializeFields();
-  mIsCustomShape = true;
-  setAcceptHoverEvents(true);
-  connect(this, SIGNAL(updateShapeAnnotation()), mpGraphicsView, SLOT(addClassAnnotation()));
-}
-
-RectangleAnnotation::RectangleAnnotation(QString shape, GraphicsView *graphicsView, QGraphicsItem *pParent)
-  : ShapeAnnotation(graphicsView, pParent)
-{
-  // initialize all fields with default values
-  initializeFields();
-  parseShapeAnnotation(shape, mpGraphicsView->getModelWidget()->getModelWidgetContainer()->getMainWindow()->getOMCProxy());
-  mIsCustomShape = true;
-  setAcceptHoverEvents(true);
-  connect(this, SIGNAL(updateShapeAnnotation()), mpGraphicsView, SLOT(addClassAnnotation()));
-}
-
-QRectF RectangleAnnotation::boundingRect() const
-{
-  return shape().boundingRect();
-}
-
-QPainterPath RectangleAnnotation::shape() const
-{
-  QPainterPath path;
-  path.addRoundedRect(getBoundingRect(), mCornerRadius, mCornerRadius);
-  return addPathStroker(path);
-}
-
-void RectangleAnnotation::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
-{
-  Q_UNUSED(option);
-  Q_UNUSED(widget);
-
-  if (transformOriginPoint() != boundingRect().center())
-  {
-    setTransformOriginPoint(boundingRect().center());
-  }
-
-  drawRectangleAnnotaion(painter);
-}
-
-void RectangleAnnotation::drawRectangleAnnotaion(QPainter *painter)
-{
-  QPainterPath path;
-
-  switch (this->mFillPattern)
-  {
-    case Qt::LinearGradientPattern:
-    {
-      QLinearGradient gradient(getBoundingRect().center().x(), getBoundingRect().center().y(),
-                               getBoundingRect().center().x(), getBoundingRect().y());
-      gradient.setColorAt(0.0, this->mFillColor);
-      gradient.setColorAt(1.0, this->mLineColor);
-      gradient.setSpread(QGradient::ReflectSpread);
-      painter->setBrush(gradient);
-      break;
-    }
-    case Qt::Dense1Pattern:
-    {
-      QLinearGradient gradient(getBoundingRect().center().x(), getBoundingRect().center().y(),
-                               getBoundingRect().x(), getBoundingRect().center().y());
-      gradient.setColorAt(0.0, this->mFillColor);
-      gradient.setColorAt(1.0, this->mLineColor);
-      gradient.setSpread(QGradient::ReflectSpread);
-      painter->setBrush(gradient);
-      break;
-    }
-    case Qt::RadialGradientPattern:
-    {
-      QRadialGradient gradient(getBoundingRect().center().x(), getBoundingRect().center().y(),
-                               getBoundingRect().width());
-      gradient.setColorAt(0.0, this->mFillColor);
-      gradient.setColorAt(1.0, this->mLineColor);
-      gradient.setSpread(QGradient::ReflectSpread);
-      painter->setBrush(gradient);
-      break;
-    }
-    default:
-      painter->setBrush(QBrush(this->mFillColor, mFillPattern));
-      break;
-  }
-
-  // make the pen width upper rounded if rectangle is rounded
-  qreal thickness;
-  // if (mCornerRadius > 0) // this is commented intentionally so that we dont need path stroker. Also helps in svg rendering
-  thickness = ceil(mThickness);
-
-  QPen pen(mLineColor, thickness, mLinePattern);
-  pen.setCosmetic(true);
-  painter->setPen(pen);
-
-  path.addRoundedRect(getBoundingRect(), mCornerRadius, mCornerRadius);
-  painter->drawPath(path);
-}
-
-void RectangleAnnotation::addPoint(QPointF point)
-{
-  mExtent.append(point);
-}
-
-void RectangleAnnotation::updateEndPoint(QPointF point)
-{
-  mExtent.back() = point;
-}
-
-void RectangleAnnotation::drawRectangleCornerItems()
-{
-  mIsFinishedCreatingShape = true;
-  for (int i = 0 ; i < this->mExtent.size() ; i++)
-  {
-    QPointF point = this->mExtent.at(i);
-    RectangleCornerItem *rectangleCornerItem = new RectangleCornerItem(point.x(), point.y(), i, this);
-    mRectangleCornerItemsList.append(rectangleCornerItem);
-  }
-  emit updateShapeAnnotation();
-}
-
-QString RectangleAnnotation::getShapeAnnotation()
-{
-  QString annotationString;
-  annotationString.append("Rectangle(");
-
-  if (!mVisible)
-  {
-    annotationString.append("visible=false,");
-  }
-
-  annotationString.append("rotation=").append(QString::number(this->rotation())).append(",");
-
-  annotationString.append("lineColor={");
-  annotationString.append(QString::number(mLineColor.red())).append(",");
-  annotationString.append(QString::number(mLineColor.green())).append(",");
-  annotationString.append(QString::number(mLineColor.blue()));
-  annotationString.append("},");
-
-  annotationString.append("fillColor={");
-  annotationString.append(QString::number(mFillColor.red())).append(",");
-  annotationString.append(QString::number(mFillColor.green())).append(",");
-  annotationString.append(QString::number(mFillColor.blue()));
-  annotationString.append("},");
-
-  QMap<QString, Qt::PenStyle>::iterator it;
-  for (it = this->mLinePatternsMap.begin(); it != this->mLinePatternsMap.end(); ++it)
-  {
-    if (it.value() == mLinePattern)
-    {
-      annotationString.append("pattern=LinePattern.").append(it.key()).append(",");
-      break;
-    }
-  }
-
-  QMap<QString, Qt::BrushStyle>::iterator fill_it;
-  for (fill_it = this->mFillPatternsMap.begin(); fill_it != this->mFillPatternsMap.end(); ++fill_it)
-  {
-    if (fill_it.value() == mFillPattern)
-    {
-      annotationString.append("fillPattern=FillPattern.").append(fill_it.key()).append(",");
-      break;
-    }
-  }
-
-  annotationString.append("lineThickness=").append(QString::number(mThickness)).append(",");
-  annotationString.append("extent={{");
-  annotationString.append(QString::number(mapToScene(mExtent.at(0)).x())).append(",");
-  annotationString.append(QString::number(mapToScene(mExtent.at(0)).y())).append("},{");
-  annotationString.append(QString::number(mapToScene(mExtent.at(1)).x())).append(",");
-  annotationString.append(QString::number(mapToScene(mExtent.at(1)).y()));
-
-  annotationString.append("}}");
-
-  annotationString.append(")");
-  return annotationString;
-}
-
-void RectangleAnnotation::updatePoint(int index, QPointF point)
-{
-
-  mExtent.replace(index, point);
-}
-
-void RectangleAnnotation::parseShapeAnnotation(QString shape, OMCProxy *omc)
-{
-  // Remove { } from shape
-
-  shape = shape.replace("{", "");
-  shape = shape.replace("}", "");
-
-  // parse the shape to get the list of attributes of Rectangle.
-  QStringList list = StringHandler::getStrings(shape);
-  if (list.size() < 16)
-  {
-    return;
-  }
-
-  // if first item of list is true then the Rectangle should be visible.
-  this->mVisible = static_cast<QString>(list.at(0)).contains("true");
-
-  int index = 0;
-  mOrigin.setX(static_cast<QString>(list.at(1)).toFloat());
-  mOrigin.setY(static_cast<QString>(list.at(2)).toFloat());
-  mRotation = static_cast<QString>(list.at(3)).toFloat();
-  index = 3;
-  // 2,3,4 items of list contains the line color.
-  index = index + 1;
-  int red, green, blue;
-
-  red = static_cast<QString>(list.at(index)).toInt();
-  index = index + 1;
-  green = static_cast<QString>(list.at(index)).toInt();
-  index = index + 1;
-  blue = static_cast<QString>(list.at(index)).toInt();
-  this->mLineColor = QColor (red, green, blue);
-
-  // 5,6,7 items of list contains the fill color.
-  index = index + 1;
-  red = static_cast<QString>(list.at(index)).toInt();
-  index = index + 1;
-  green = static_cast<QString>(list.at(index)).toInt();
-  index = index + 1;
-  blue = static_cast<QString>(list.at(index)).toInt();
-  this->mFillColor = QColor (red, green, blue);
-
-  // 8 item of the list contains the line pattern.
-  index = index + 1;
-  QString linePattern = StringHandler::getLastWordAfterDot(list.at(index));
-  QMap<QString, Qt::PenStyle>::iterator it;
-  for (it = this->mLinePatternsMap.begin(); it != this->mLinePatternsMap.end(); ++it)
-  {
-    if (it.key().compare(linePattern) == 0)
-    {
-      this->mLinePattern = it.value();
-      break;
-    }
-  }
-
-  // 9 item of the list contains the fill pattern.
-  index = index + 1;
-  QString fillPattern = StringHandler::getLastWordAfterDot(list.at(index));
-  QMap<QString, Qt::BrushStyle>::iterator fill_it;
-  for (fill_it = this->mFillPatternsMap.begin(); fill_it != this->mFillPatternsMap.end(); ++fill_it)
-  {
-    if (fill_it.key().compare(fillPattern) == 0)
-    {
-      this->mFillPattern = fill_it.value();
-      break;
-    }
-  }
-
-  // 10 item of the list contains the thickness.
-  index = index + 1;
-  this->mThickness = static_cast<QString>(list.at(index)).toFloat();
-
-  // 11 item of the list contains the border pattern.
-  index = index + 1;
-  QString borderPattern = StringHandler::getLastWordAfterDot(list.at(index));
-  QMap<QString, Qt::BrushStyle>::iterator border_it;
-  for (border_it = this->mBorderPatternsMap.begin(); border_it != this->mBorderPatternsMap.end(); ++border_it)
-  {
-    if (border_it.key() == borderPattern)
-    {
-      this->mBorderPattern = border_it.value();
-      break;
-    }
-  }
-
-  // 12, 13, 14, 15 items of the list contains the extent points of rectangle.
-  index = index + 1;
-  qreal x = static_cast<QString>(list.at(index)).toFloat();
-  index = index + 1;
-  qreal y = static_cast<QString>(list.at(index)).toFloat();
-  QPointF p1 (x, y);
-  index = index + 1;
-  x = static_cast<QString>(list.at(index)).toFloat();
-  index = index + 1;
-  y = static_cast<QString>(list.at(index)).toFloat();
-  QPointF p2 (x, y);
-
-  this->mExtent.append(p1);
-  this->mExtent.append(p2);
-
-  // 16 item of the list contains the corner radius.
-  index = index + 1;
-  this->mCornerRadius = static_cast<QString>(list.at(index)).toFloat();
-}
Index: /branches/OMEdit/OMEditGUI/RectangleAnnotation.h
===================================================================
--- /branches/OMEdit/OMEditGUI/RectangleAnnotation.h	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/RectangleAnnotation.h	(revision 13537)
@@ -41,11 +41,11 @@
 
 class OMCProxy;
-class Component_OMC;
+class Component;
 
-class RectangleAnnotation_OMC : public ShapeAnnotation_OMC
+class RectangleAnnotation : public ShapeAnnotation
 {
   Q_OBJECT
 public:
-  RectangleAnnotation_OMC(QString annotation, Component_OMC *pParent);
+  RectangleAnnotation(QString annotation, Component *pParent);
   void parseShapeAnnotation(QString annotation);
   QRectF boundingRect() const;
@@ -58,26 +58,3 @@
 };
 
-
-class RectangleAnnotation : public ShapeAnnotation
-{
-  Q_OBJECT
-public:
-  RectangleAnnotation(QString shape, Component *pParent);
-  RectangleAnnotation(GraphicsView *graphicsView, QGraphicsItem *pParent = 0);
-  RectangleAnnotation(QString shape, GraphicsView *graphicsView, QGraphicsItem *pParent = 0);
-  QRectF boundingRect() const;
-  QPainterPath shape() const;
-  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget = 0);
-  void drawRectangleAnnotaion(QPainter *painter);
-  void addPoint(QPointF point);
-  void updateEndPoint(QPointF point);
-  void drawRectangleCornerItems();
-  QString getShapeAnnotation();
-  void parseShapeAnnotation(QString shape, OMCProxy *omc);
-
-  Component *mpCompnent;
-public slots:
-  void updatePoint(int index, QPointF point);
-};
-
 #endif // RECTANGLEANNOTATION_H
Index: /branches/OMEdit/OMEditGUI/SearchClassDialog.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/SearchClassDialog.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/SearchClassDialog.cpp	(revision 13537)
@@ -114,4 +114,8 @@
 }
 
+void SearchClassSuggestion::setClassesList(QStringList classes)
+{
+  mClassesList = classes;
+}
 
 bool SearchClassSuggestion::eventFilter(QObject *pObject, QEvent *event)
@@ -206,8 +210,5 @@
     return;
   }
-  MainWindow* pMainWindow = mpSearchClassBox->getSearchClassDialog()->getMainWindow();
   QStringList foundedItemsList;
-  mClassesList.clear();
-  mClassesList = pMainWindow->getOMCProxy()->getClassNames("", "true");
   foreach (QString item, mClassesList)
   {
@@ -336,2 +337,17 @@
   mpMainWindow->openLibraryTreeNode(pItem, mpDontOpenClassCheckBox->isChecked());
 }
+
+//! Checks the activation of the dialog.
+//! Only fetch the classes from OMC once when the dialog becomes active.
+//! @param QEvent
+void SearchClassDialog::changeEvent(QEvent *event)
+{
+  if (event->type() == QEvent::ActivationChange)
+  {
+    if (isActiveWindow())
+    {
+      mpSearchClassTextBox->getSearchClassSuggestion()->getClassesList().clear();
+      mpSearchClassTextBox->getSearchClassSuggestion()->setClassesList(getMainWindow()->getOMCProxy()->getClassNames("", "true"));
+    }
+  }
+}
Index: /branches/OMEdit/OMEditGUI/SearchClassDialog.h
===================================================================
--- /branches/OMEdit/OMEditGUI/SearchClassDialog.h	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/SearchClassDialog.h	(revision 13537)
@@ -64,4 +64,5 @@
   SearchClassBox* getSearchClassBox();
   QStringList getClassesList();
+  void setClassesList(QStringList classes);
   bool eventFilter(QObject *pObject, QEvent *event);
   void showCompletion(const QStringList &choices);
@@ -96,4 +97,6 @@
   void searchClasses();
   void openLibraryTreeNode(QTreeWidgetItem *pItem, int column);
+protected:
+  virtual void changeEvent(QEvent *event);
 };
 
Index: /branches/OMEdit/OMEditGUI/ShapeAnnotation.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/ShapeAnnotation.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/ShapeAnnotation.cpp	(revision 13537)
@@ -104,5 +104,5 @@
 }
 
-ShapeAnnotation_OMC::ShapeAnnotation_OMC(QGraphicsItem *parent)
+ShapeAnnotation::ShapeAnnotation(QGraphicsItem *parent)
   : QGraphicsItem(parent)
 {
@@ -110,5 +110,5 @@
 }
 
-QPainterPath ShapeAnnotation_OMC::addPathStroker(QPainterPath &path) const
+QPainterPath ShapeAnnotation::addPathStroker(QPainterPath &path) const
 {
   QPainterPathStroker stroker;
@@ -117,5 +117,5 @@
 }
 
-QRectF ShapeAnnotation_OMC::getBoundingRect() const
+QRectF ShapeAnnotation::getBoundingRect() const
 {
   QPointF p1 = mExtent.size() > 0 ? mExtent.at(0) : QPointF(-100.0, -100.0);
@@ -128,5 +128,5 @@
 }
 
-void ShapeAnnotation_OMC::applyLinePattern(QPainter *painter)
+void ShapeAnnotation::applyLinePattern(QPainter *painter)
 {
   qreal thickness;
@@ -137,5 +137,5 @@
 }
 
-void ShapeAnnotation_OMC::applyFillPattern(QPainter *painter)
+void ShapeAnnotation::applyFillPattern(QPainter *painter)
 {
   switch (mFillPattern)
